#include<stdio.h>
#include<math.h>
void main(){
	int n,m,i,j,Q;
	scanf("%d",&n);
	scanf("%d",&m);
	int matrica[n][m];
	for(i=0;i<n;i++){
		for(j=0;j<m;j++){
			scanf("%d",&matrica[i][j]);
		}
	}
	scanf("%d",&Q);
	int matrica1[Q][2];
	for(i=0;i<Q;i++){
		for(j=0;j<2;j++){
			scanf("%d",&matrica1[i][j]);
		}
	}
	int k;
	for(k=0;k<Q;k++){
		int trenutni_red=0,trenutna_kolona=0,broj_navijaca=0;
		int napred_vrsta = -1, napred_kolona = -1;
	while (trenutni_red != n-1 && trenutna_kolona != m-1) {
		if (trenutni_red + 1 < n && trenutni_red+1 != matrica1[k][0] && trenutna_kolona != matrica1[k][1])
			napred_vrsta = matrica[trenutni_red+1][trenutna_kolona];
		if (trenutna_kolona + 1 < m && trenutni_red != matrica1[k][0] && trenutna_kolona+1 != matrica1[k][1])
			napred_kolona = matrica[trenutni_red][trenutna_kolona+1];
		if (napred_vrsta < napred_kolona && napred_vrsta != -1) {
			broj_navijaca += napred_vrsta;
			trenutni_red += 1;
		}
		if (napred_kolona < napred_vrsta && napred_kolona != -1) {
			broj_navijaca += napred_kolona;
			trenutna_kolona += 1;
		}
		napred_vrsta=-1;
		napred_kolona=-1;
		
	}

	printf("%d %d %d", matrica1[k][0], matrica1[k][1], broj_navijaca);
}
}